﻿using System.Collections.Generic;
using System.Reflection;
using JetBrains.Annotations;
using JetBrains.Application;
using JetBrains.Threading;
using JetBrains.Util;
using NUnit.Framework;

[assembly: TestDataPathBase(@".\Data")]

// ReSharper disable once CheckNamespace
[SetUpFixture]
public class Environment : ReSharperTestEnvironmentAssembly
{
    private static IEnumerable<Assembly> GetAssembliesToLoad()
    {
        yield break;
    }

    public override void SetUp()
    {
        base.SetUp();
        ReentrancyGuard.Current.Execute("LoadAssemblies", () =>
        {
            var assemblyManager = Shell.Instance.GetComponent<AssemblyManager>();
            assemblyManager.LoadAssemblies(GetType().Name, GetAssembliesToLoad());
        });
    }

    public override void TearDown()
    {
        ReentrancyGuard.Current.Execute("UnloadAssemblies", () =>
        {
            var assemblyManager = Shell.Instance.GetComponent<AssemblyManager>();
            assemblyManager.UnloadAssemblies(GetType().Name, GetAssembliesToLoad());
        });

        base.TearDown();
    }
}